import java.awt.*;


/**
 * Trida pro praci s trojuhelnikem na virtualnim platne.
 * Je soucasti projektu Tvary, ktery slouzi k demonstraci moznosti 
 * vyuky objektove orientovaneho programovani.
 *
 * @author     Rudolf Pecinvosky
 * @version    1.0, prosinec 2002
 */

public class Trojuhelnik
{
//== ATRIBUTY TRIDY ============================================================

    /**
     *  Pocatecni barva nakresleneho trojuhelniku v pripade,
     *  kdy uzivatel zadnou pozadovanou barvu nezada.
     */
    public static final String POC_BARVA = "zelena";

    private static int    krok   = 50;


//== ATRIBUTY INSTANCI =========================================================

    private int xPos;
    private int yPos;
    private int sirka;
    private int vyska;
    private String barva;


//== PRISTUPOVE METODY ATRIBUTU TRIDY ==========================================

    /**
     * Vrati velikost implicitniho kroku, o ktery se trojuhelnik presune
     * pri volani bezparametrickych metod presunu.
     *
     * @return velikost implicitniho kroku v bodech
     */
     public int getKrok()
     {
         return krok;
     }//public int getKrok()


    /**
     * Nastavi velikost implicitniho kroku, o ktery se trojuhelnik presune
     * pri volani bezparametrickych metod presunu.
     *
     * @param velikost  velikost implicitniho kroku v bodech; velikost>=0
     */
    public void setKrok( int velikost )
    {
        if( velikost < 0 )
            throw new IllegalArgumentException(
                "Krok nesmi byt zaporny." );
        krok = velikost;
    }//public int getY()



//== KONSTRUKTORY ==============================================================

    /**
     * Vytvori novy trojuhelnik s implicitnimi rozmery, umistenim a barvou.
     * Trojuhelnik bude umisten v levem hornim rohu a bude mit
     * (na pocatku zelenou) barvu, vysku 40 bodu a sirku 40 bodu.
     */
    public Trojuhelnik()
    {
        this( 0, 0, 40, 40 );
    }//public Trojuhelnik()


    /**
     * Vytvori novy trojuhelnik se zadanou polohou a rozmery
     * a implicitni (na pocatku zelenou) barvou.
     *
     * @param x x-ova souradnice, x>=0, x=0 ma levy okraj platna
     * @param y y-ova souradnice, y>=0, y=0 ma horni okraj platna
     * @param w sirka trojuhelniku,  w > 0
     * @param h vyska trojuhelniku,  h > 0
     */
    public Trojuhelnik( int x, int y, int w, int h )
    {
        this( x, y, w, h, POC_BARVA );
    }//public Trojuhelnik( int x, int y, int w, int h )


    /**
     * Vytvori novy trojuhelnik se zadanymi rozmery, polohou a barvou.
     *
     * @param x   x-ova souradnice, x>=0, x=0 ma levy okraj platna
     * @param y   y-ova souradnice, y>=0, y=0 ma horni okraj platna
     * @param w sirka trojuhelniku,  w > 0
     * @param h vyska trojuhelniku,  h > 0
     * @param c barva trojuhelniku - povolene hodnoty jsou:
     *                    "cerna",  "modra",     "cervena", "fialova",
     *                    "zelena", "blankytna", "zluta",   "bila".
     */
    public Trojuhelnik( int x, int y, int w, int h, String c )
    {
        //Test platnosti parametru
        if( (x<0) || (y<0) || (w<=0) || (h<=0) )
            throw new IllegalArgumentException(
                "Parametry nemaji povolene hodnoty: x="
                + x + ", y=" + y + ", w=" + w + ", h=" + h );
        Platno.getPlatno().setBarvaPopredi( c );

        //Parametry akceptovany --> muzeme tvorit
        vyska = h;
        sirka = w;
        xPos = x;
        yPos = y;
        barva = c;
        kresli();
    }//public Trojuhelnik( int x, int y, int w, int h )



//== PRISTUPOVE METODY ATRIBUTU INSTANCI =======================================

    /**
     * Vrati x-ovou souradnici trojuhelniku, tj. souradnici
     * leveho horniho rohu opsaneho obdelniku.
     *
     * @return x-ova souradnice leveho horniho rohu opsaneho obdelniku
     */
     public int getX()
     {
         return xPos;
     }//public int getX()


    /**
     * Vrati y-ovou souradnici trojuhelniku, tj. souradnici
     * leveho horniho rohu opsaneho obdelniku.
     *
     * @return y-ova souradnice leveho horniho rohu opsaneho obdelniku
     */
     public int getY()
     {
         return yPos;
     }//public int getY()


    /**
     * Nastavi novou polohu trojuhelniku, tj. polohu
     * leveho horniho rohu opsaneho obdelniku.
     *
     * @param x   x-ova pozice leveho horniho rohu opsaneho obdelniku
     * @param y   y-ova pozice leveho horniho rohu opsaneho obdelniku
     */
    public void setPozice(int x, int y)
    {
        smaz();
        xPos = x;
        yPos = y;
        kresli();
    }//public void setPozice(int x, int y)


    /**
     * Vrati sirku trojuhelniku.
     *
     * @return  sirka trojuhelniku v bodech
     */
     public int getSirka()
     {
         return sirka;
     }//public int getSirka()


    /**
     * Vrati vysku trojuhelniku.
     *
     * @return  vyska trojuhelniku v bodech
     */
     public int getVyska()
     {
         return vyska;
     }//public int getVyska()


    /**
     * Nastavi novou velikost trojuhelniku -
     * na zadanou velikost se nastavi vyska i sirka.
     *
     * @param velikost  nove nastavovana velikost; velikost>0
     */
    public void setVelikost(int velikost)
    {
        setRozmer( velikost, velikost );
    }//public void setVelikost(int velikost)


    /**
     * Nastavi nove rozmery trojuhelniku.
     *
     * @param w    nove nastavovana sirka; w>0
     * @param h    nove nastavovana vyska; h>0
     */
    public void setRozmer(int w, int h)
    {
        if( (w <= 0) || (h <= 0) )
            throw new IllegalArgumentException(
                "Rozmery musi byt kladne: w=" + w + ", h=" + h );
        smaz();
        sirka = w;
        vyska = h;
        kresli();
    }//public void setRozmer(int rozmer)


    /**
     * Vráti barvu trojuhelniku.
     *
     * @return  retezec definujici nastavenou barvu
     */
    public String getBarva()
    {
        return barva;
    }//public String getBarva()


    /**
     * Nastavi novou barvu trojuhelniku.
     *
     * @param nova nova barva - povolene hodnoty jsou:
     *                    "cerna",  "modra",     "cervena", "fialova",
     *                    "zelena", "blankytna", "zluta",   "bila".
     */
    public void setBarva(String nova)
    {
        //Nejprve otestuje akceptovatelnost nastavovane barvy
        Platno platno = Platno.getPlatno();
        platno.setBarvaPopredi( nova ); //Zkus nastavit zadavanou barvu
        barva = nova;                   //Proslo to --> nastav ji
        kresli();
    }//public void setBarva(String nova)



//== OSTATNI METODY INSTANCI ===================================================

    /**
     * Nakresli trojuhelnik na platno.
     */
    protected void kresli()
    {
        Platno platno = Platno.getPlatno();
        platno.setBarvaPopredi(barva);
        int[] xpoints = { xPos, xPos + (sirka/2), xPos + sirka };
        int[] ypoints = { yPos + vyska, yPos, yPos + vyska };
        platno.zapln(new Polygon(xpoints, ypoints, 3));
    }//protected void kresli()


    /**
     * Smaze dany trojuhelnik, tj. nakresli jej barvou pozadi platna.
     */
    protected void smaz()
    {
        Platno platno = Platno.getPlatno();
        int[] xpoints = { xPos, xPos + (sirka/2), xPos + sirka };
        int[] ypoints = { yPos + vyska, yPos, yPos + vyska };
        platno.smaz(new Polygon(xpoints, ypoints, 3));
    }//protected void smaz()


    /**
     * Presune trojuhelnik o zadany pocet bodu vpravo,
     * pri zaporne hodnote parametru vlevo.
     *
     * @param vzdalenost vzdalenost, o kterou se trojuhelnik presune
     */
    public void posunVpravo(int vzdalenost)
    {
        smaz();
        xPos += vzdalenost;
        kresli();
    }//public void posunVpravo(int vzdalenost)


    /**
     * Presun trojuhelnik o krok bodu vpravo.
     */
    public void posunVpravo()
    {
        posunVpravo(krok);
    }//public void posunVpravo()


    /**
     * MPresun trojuhelnik o krok bodu vlevo.
     */
    public void posunVlevo()
    {
        posunVpravo(-krok);
    }//public void posunVlevo()


    /**
     * Pomalu presun trojuhelnik o zadany pocet bodu vpravo,
     * pri zaporne hodnote parametru vlevo.
     *
     * @param vzdalenost pocet bodu, o ktere se trojuhelnik presune.
     */
    public void pomaluVpravo(int vzdalenost)
    {
        int delta;

        if(vzdalenost < 0)
        {
            delta = -1;
            vzdalenost = -vzdalenost;
        }
        else
        {
            delta = 1;
        }

        for(int i = 0; i < vzdalenost; i++)
        {
            posunVpravo( delta );
            Platno.getPlatno().cekej(10);
        }
    }//public void pomaluVpravo(int vzdalenost)


    /**
     * Presune trojuhelnik o zadany pocet bodu dolu,
     * pri zaporne hodnote parametru nahoru.
     *
     * @param vzdalenost pocet bodu, o ktere se trojuhelnik presune
     */
    public void posunDolu(int vzdalenost)
    {
        smaz();
        yPos += vzdalenost;
        kresli();
    }//public void posunDolu(int vzdalenost)


    /**
     * Presune trojuhelnik o krok bodu nahoru.
     */
    public void posunVzhuru()
    {
        posunDolu(-krok);
    }//public void posunVzhuru()


    /**
     * Presune trojuhelnik o krok bodu dolu.
     */
    public void posunDolu()
    {
        posunDolu(krok);
    }//public void posunDolu()


    /**
     * Pomalu presune trojuhelnik o zadany pocet bodu dolu,
     * pri zaporne hodnote parametru nahoru.
     *
     * @param vzdalenost pocet bodu, o ktere se trojuhelnik presune
     */
    public void pomaluDolu(int vzdalenost)
    {
        int delta;

        if(vzdalenost < 0)
        {
            delta = -1;
            vzdalenost = -vzdalenost;
        }
        else
        {
            delta = 1;
        }

        for(int i = 0; i < vzdalenost; i++)
        {
            posunDolu( delta );
            Platno.getPlatno().cekej(10);
        }
    }//public void pomaluDolu(int vzdalenost)

}//public class Trojuhelnik